//Copyright (C) 2003 Daniel De Graaf

////////////////////////////////
//      Calculator Check      //
////////////////////////////////
#if defined(Ver89)
#define USE_TI89
#define Q(x,y) x
#else
#define USE_TI92PLUS
#define USE_V200
#define Q(x,y) y
#endif

////////////////////////////////
//     TIGCC Header File      //
////////////////////////////////
#define OPTIMIZE_ROM_CALLS
#define MIN_AMS 200

#include <tigcclib.h>

////////////////////////////////
//        Custom Types        //
////////////////////////////////
typedef union { WORD x; struct {BYTE H, W;} d;} MazeDim; 
//complicated union of word and 2 bytes
typedef struct {BYTE H,W,T,P;} MazeDat;

////////////////////////////////
//          Constants         //
////////////////////////////////
//Load
#define ScrH Q(100,128)
#define ScrW Q(160,240)

//Options
extern MazeDat setting;
#define H_Min 6
#define H_Max ScrH
#define H_Step 2
#define W_Min 6
#define W_Max ScrW
#define W_Step 2
#define T_Min 3
#define T_Max 240
#define T_Step 1
#define P_Min 1
#define P_Max 200
#define P_Step 1

//Make sure I'm using my rowread function instead of kbd.h's
#pragma poison _rowread

#define __Keytest(row,col) rowread(1<<(row)) & (1<<(col))
#define _Keytest(rowcol...) (__Keytest(rowcol))

////////////////////////////////
//        ASM Functions       //
////////////////////////////////
#define asmF(n) __attribute__ ((regparm(n)))
void make(char*) asmF(1);
void solve(char*) asmF(1);
void play(char*) asmF(1);
void disp(char*) asmF(1);
void DispMenu();
void DrawStrR(short, const char*) asmF(1);
BYTE rowread(WORD x) asmF(1);
extern char* TXT_Maze;
extern char* P_TXT_Maze;
extern char set_W;
extern char set_H;
void SetInts(void);
void RestoreInts(void);

