//////////////////////////////////////////////////////////////
//            Copyright (C) 2003 Daniel De Graaf            //
//                                                          //
//                         Maze 1.7                         //
//                                                          //
//                Compile using TIGCC v0.94                 //
//                                                          //
//        If you make any changes, you must compile         //
//     for both calculators. Comment out the first line     //
//       in Internal.s when compiling for the TI-92+        //
//////////////////////////////////////////////////////////////
#define	Ver89

#include "constants.h"

////////////////////////////////
//   C Function Definitions   //
////////////////////////////////
void Main   (char*);
void save   (char*);
void load   (char*);
BOOL Option ();

////////////////////////////////
//         Functions          //
////////////////////////////////
void Main(char* theMaze) {
	DispMenu(); while (1) {
     if (_Keytest(RR_1)) make(theMaze);
else if (_Keytest(RR_2)) solve(theMaze);
else if (_Keytest(RR_3)) play(theMaze);
else if (_Keytest(RR_4)) save(theMaze);
else if (_Keytest(RR_5)) load(theMaze);
else if (_Keytest(RR_6)) disp(theMaze);
else if (_Keytest(RR_7)) {if (Option())	make(theMaze);}
else if (_Keytest(RR_8)) break;
else continue;
	DispMenu();
}}

void save(char* theMaze) {
	MazeDim dim; dim.x = *(WORD*)(&setting);
	BYTE type[] = {OTH_TAG,PIC_TAG,0};
	RestoreInts();
	HSym r=VarNew(type, &P_TXT_Maze);
	SetInts();
	if (!(r.folder)) return;
	if (*(WORD*)VarOptList == 1) { //from TI's documentation...TIGCC Unknown.h
		short CMP_Size =
		 2 + //Height&width bytes
		 (dim.d.H/2) * //height, round down
		 (dim.d.W/8 + 1) + //width, round up
		 7; //Tag info
		HANDLE t = HeapAlloc(CMP_Size+2);
		if (t == H_NULL) return;
		BYTE* data = HeapDeref(DerefSym(r)->handle = t);
		data[0] = CMP_Size/256;
		data[1] = CMP_Size%256;
		data[2] = dim.d.W;
		data[3] = dim.d.H;
		BYTE c,o,g=dim.d.W/8 + 1;
		for(c=0; c < dim.d.H/2; c++) for(o=0; o<g; o++)
			data[4 + c*g + o] =
				(theMaze[c*60+o] & 0x55) |
				 theMaze[c*60+30+o]; //the 0xAA bits are already clear
		memcpy(data+CMP_Size-5,(char*)(&TXT_Maze)-1,7);
	} else {
		SCR_RECT rect = {{0,0,dim.d.W,dim.d.H}};
		short BMP_Size = BitmapSize(&rect)+2;
		HANDLE t = HeapAlloc(BMP_Size+2);
		if (t == H_NULL) return;
		BYTE* data = HeapDeref(DerefSym(r)->handle = t);
		PortSet(theMaze, 239, 127);
		BitmapGet(&rect, data+2);
		PortRestore();
		data[0] = BMP_Size/256;
		data[1] = BMP_Size%256;
		data[BMP_Size+1] = PIC_TAG;
}	}

void load(char* theMaze) {
	BYTE type[] = {OTH_TAG,PIC_TAG,0};
	MazeDim dim;
	RestoreInts();
	HSym r=VarOpen(type, &P_TXT_Maze);
	SetInts();
	if (!(r.folder)) return;
	BYTE* data=HeapDeref(DerefSym(r)->handle);
	WORD tmp = *(WORD*)(data);
	if (data[tmp+1] == PIC_TAG) {
		dim.d.W = *(WORD*)(data+2)-1;
		dim.d.H = *(WORD*)(data+4)-1;
		if (dim.d.W > ScrW || dim.d.H > ScrH) return;
		SCR_RECT rect = {{0,0,dim.d.W-1,dim.d.H-1}};
		PortSet(theMaze, 239, 127);
		BitmapPut(0, 0, data+2, &rect, A_REPLACE);
		PortRestore();
	} else if (data[tmp+1] == OTH_TAG) {
		dim.d.W = data[2];
		dim.d.H = data[3];
		if (dim.d.W > ScrW || dim.d.H > ScrH) return;
		char c=0, o=0, g=dim.d.W/8+1;
		for(c=0; c < dim.d.H/2; c++) for(o=0; o<g; o++) {
			theMaze[c*60+o] = data[4+c*g+o] | 0xAA;
			theMaze[c*60+30+o] = data[4+c*g+o] & 0xAA;
		} g--;
		for(c=0; c < dim.d.H; c++) theMaze[c*60+g] &= 0x80;
	}
	*(WORD*)(&setting) = dim.x; //it is on an even address
}

BOOL Option() {
	BYTE W=setting.W,H=setting.H;
	ClrScr();
	FontSetSys(F_8x10);
	DrawStrR(5,"Options");
	FontSetSys(F_6x8);
	DrawStrR(20,"Hold F1-F4; ESC = exit");
	//Add:           012345678901234567890123456789
	const char* ct = "Cutoff Threshold =    ";
	const char* cp = "    Probability = 1/   ";
	const char* mw = "Maze Width =    ";
	const char* mh = "Maze Height =    ";
	const char* fm = "%3d";
	while (!_Keytest(RR_ESC) && !_Keytest(RR_ENTER)) {
		sprintf((char*)(ct+19),fm,setting.T);       DrawStrR(30,ct);
		sprintf((char*)(cp+20),fm,setting.P);       DrawStrR(40,cp);
		sprintf((char*)(mw+13),fm,setting.W/2); DrawStrR(50,mw);
		sprintf((char*)(mh+14),fm,setting.H/2); DrawStrR(60,mh);		
		if (!_Keytest(RR_2ND)) asm("
	move.l (0x29B*4,%%a5),%%a2
	jbsr (%%a2); jbsr (%%a2)
	jbsr (%%a2); jbsr (%%a2)
	jbsr (%%a2); jbsr (%%a2)
" : : : "a0", "a1", "a2", "d0", "d1", "d2");
#define SetOptFor(v,x,n)                     \
	if (_Keytest(RR_F ## n)) {               \
		if (_Keytest(RR_UP))   v += x ## _Step;\
		if (_Keytest(RR_DOWN)) v -= x ## _Step;\
		if (v <= x ## _Min) v += x ## _Step;     \
		if (v >= x ## _Max) v -= x ## _Step;     \
	} //variable, limitprefix, Fn
		     SetOptFor(setting.T, T,1)
		else SetOptFor(setting.P, P,2)
		else SetOptFor(setting.W, W,3)
		else SetOptFor(setting.H, H,4)
	}
short r; asm("
	clr.w %0
	cmp.b set_W,%1
	jbeq L178
L168:
	moveq.l #1,%0
	jbra L167
	.even
L178:
	cmp.b set_H,%2
	jbne L168
L167:
" : "=d" (r) : "d" (W), "d" (H));
	return r;
}

/*
#define GetScrnP(x,y) GetP(x,y,(char*)0x4C00)
#define GetMazeP(x,y) GetP(x,y,theMaze)
//void make(char* theMaze) {
	BYTE x, y, t;
	asm("move.b 0x600017,%%d0
	move.l %%d0, __randseed":::"%d0");
	ClrScr();
	for(x=0;x <= setting.dim.W; x++) { //top & bottom & corners
		DrawScrnP(x,0);
		DrawScrnP(x,setting.dim.H);
	}
	for(y=1;y < setting.dim.H-1; y++) { //sides except lowest pixel
		DrawScrnP(0,y);
		DrawScrnP(setting.dim.W,y);
	}
	DrawScrnP(0, setting.dim.H-1); //close hole on left
////Border is done////
	for(t=1;t<Iterations;t++)
		if (!GetScrnP(
			x = random((setting.dim.W-2)/2)*2+2,
			y = random((setting.dim.H-2)/2)*2+2)
		) {
			RunningLine(x,y);
			t=1; //found one, start counter over
		}

	for(x=2;x < setting.dim.W-1; x += 2) for(y=2;y < setting.dim.H-1; y += 2)
		if (!GetScrnP(x,y)) RunningLine(x,y);
	LCD_save(theMaze);
}

//void DispMenu() {
	const char* menu = 
// 	0123456789012
		"1 - Make   \0"
		"2 - Solve  \0"
		"3 - Play   \0"
		"4 - Save   \0"
		"5 - Load   \0"
		"6 - View   \0"
		"7 - Options\0"
		"8 - Exit";
	ClrScr();
	FontSetSys(F_8x10);
	DrawStrR(TitleRow, "Maze");
	FontSetSys(F_6x8);
	short tmp;
	for(tmp=0; tmp < 8; tmp++)
		DrawStrR(Menu_ItemHeight*(tmp+2), menu + tmp*12);
}

//void DrawSprite(short x, short y, BOOL clear) {//modified sprite routine
	register long addr=(0x4C00+30*8*y+x); //x and y are on 8x8 boxes
	register short i;
	if (x == YourX && y == YourY)
		for(i=0;i<8;addr+=30,i++) *(BYTE*)addr = Sperson[i];
	else
		for(i=0;i<8;addr+=30,i++) *(BYTE*)addr = clear-1; //[FF]FF or 00
}

//void solve(char* theMaze, MazeDim dim) {
	BYTE x,y;
	LCD_restore(theMaze);
	for(x=1; x < dim.W; x++) for(y=1; y < dim.H; y++)
		if (!(x==dim.W-1 && y==dim.H-2) && !GetScrnP(x,y)) TwistingLine(x,y);
	LCD_save(theMaze);
	while (!_Keytest(RR_ENTER));
}
//inline void TwistingLine(short x, short y) {
	BYTE x0,x1,y0,y1;
	while (!(x == 1 && y == 1) && 
		(x0=!GetScrnP(x-1,y  )) + 
		(x1=!GetScrnP(x+1,y  )) + 
		(y0=!GetScrnP(x  ,y-1)) +
		(y1=!GetScrnP(x  ,y+1)) == 1
	) {
		DrawScrnP(x,y);
		x += x1-x0;
		y += y1-y0;
	}
}
//void _play(char* theMaze, MazeDim dim) {
	short x=1, y=1, dx, dy;
	BOOL Rocket, Run, DELAY=0;
	ClrScr();
	while (x >= 0 && x <= dim.W && y >= 0 && y <= dim.H) { //while in maze

		for(dx=0; dx < 30; dx++) for(dy=0; dy < 16; dy++) 
		DrawSprite(dx,dy,
			x+dx-YourX < 0 || x+dx-YourX > dim.W+1 ||
			y+dy-YourY < 0 || y+dy-YourY > dim.H+1 || 
			!GetMazeP(x+dx-YourX,y+dy-YourY));
// pokeIO(0x600005,0b10111); is low-power

//idle 4x
asm("
	move.l 2668(%%a5),%%a2
0:
	jbsr (%%a2)
	jbsr (%%a2)
	jbsr (%%a2)
	jbsr (%%a2)
	subq.w #1, %0
	jbne 0b
	addq.w #1, %0
" : "=d" (DELAY) : "0" (DELAY) : "a0", "a1", "a2", "d0", "d1", "d2");
		
		if (_Keytest(RR_ESC)) return;
		if (_Keytest(RR_APPS)) disp(theMaze);
	{	register WORD key = rowread(1); //kbd.h
		dx = !!(key & 1<<Part2(RR_RIGHT)) - !!(key & 1<<Part2(RR_LEFT));
		dy = !!(key & 1<<Part2(RR_DOWN))  - !!(key & 1<<Part2(RR_UP));
		Rocket = key & 1<<Part2(RR_DIAMOND);
		Run    = key & ((1<<Part2(RR_2ND)) + (1<<Part2(RR_DIAMOND))); 
		if (key & 1<<Part2(RR_SHIFT)) dx *= 2, dy *= 2;
	}
		if (dx ^ dy) while (!GetMazeP(x+dx, y+dy)) {
			if (_Keytest(RR_ESC)) return; //escape from a long diamond movement
			x += dx;
			y += dy;
			if (2 < ( //two paths is normal - no pause
				!GetMazeP(x-1,y  ) + 
				!GetMazeP(x+1,y  ) + 
				!GetMazeP(x  ,y-1) + 
				!GetMazeP(x  ,y+1))) {
				if (!Rocket) break; //intersection - only rocket passes
			} else {
				DELAY=10;
				if (!Run) break; //moved - running keeps on going
	}	}	}
	ClrScr();	//they won
	FontSetSys(F_8x10);
	DrawStr(YouWinX, YouWinY,
		(x == dim.W+1 && y == dim.H-1) ? TXT_Win : TXT_Cheat,A_REPLACE);
	asm("jbsr WaitForEnter" ::: "a0","d0","d2");
}

//void disp(char* theMaze) {
	LCD_restore(theMaze);
	while (!_Keytest(RR_ENTER) && !_Keytest(RR_ESC));
		 //they press
	while (_Keytest(RR_ENTER) || _Keytest(RR_ESC));
		 //they release
}
//void RunningLine(short x, short y, short T, short P) {
	register char t=rand()/0x100;
	register char d=(t & 2) - 1; //1 or -1
	T &= 0xFE;
	while (!GetScrnP(x,y)) {
		DrawScrnP(x,y);
		if (T-- < 0 && !(T & 1))
			if (!random(P)) return; //only stop if it's even
		(t & 1) ? (x += d) : (y += d); //different bit for x or y
	} 
}
*/